%% DEMO_luokitteluvirhe.m
% T-61.2010 Datasta tietoon 
% Tietokoneharjoitus #3
% Demo: kNN-luokitus ja luokitteluvirhe
%
% Jukka Parviainen, jukka.parviainen@aalto.fi, 20111026

%% kNN-luokitin
%
% * testataan kNN-luokitinta 2D-dataan
% * jaetaan data opetus- ja testidataan
% * "opetetaan" kNN kytten opetusdataa
% * testidatalla voidaan laskea luokitteluvirhe

%% Kokeilu
%
% - Rivin 27 k-parametri

%% Siistimist, jos tarpeen

clear;         % poista muistista muuttujat
clc;           % puhdista komentoikkunan ruutu
close all;     % sulje kaikki ikkunat
%clear ind_data;  % jos haluat muuttaa "arvontaa"

%% kNN-luokitimmen naapureiden lukumr
kNN = 1;  % valitse joko 1, 3 tai 5. Aloitetaan 1:st.
disp('********************************************************');
disp(['kNN-luokitin: valitaan ' num2str(kNN) ' lhint naapuria']);

%% Opetus- ja testiaineisto
%
% Yleens kytettviss oleva "labeloitu" aineisto                              
% jaetaan kahteen osaan: opetus- ja testiaineistoon
% (training & test).
%
% Yleisesti luokitin opetetaan opetusdatalla, mink
% jlkeen testidatalla lasketaan luokittimen luokitteluvirhe.
% Tmn jlkeen luokitinta kytetn aivan uuteen
% dataan, josta luokkaa ei tunneta vaan luokitin antaa sen.                             
%
% Ladataan data ja luokkatieto

load DT_T3_D.mat
disp('Ladattiin muuttujat "data" ja "dclass"');
disp('Jokaiseen 2D-datapisteeseen liitty luokkatieto +1/-1, esim.');
disp(data(:, [1 70 130])); % tulostetaan kolme "satunnaista"
disp(dclass([1 70 130]));

%% Jaetaan data opetus- ja testijoukkoon
% Valitaan satunnaisesti 80% datasta opetukseen ja
%  20% testaukseen.
% 
% Luokkana joko -1 tai +1.

N = size(data, 2);
if (exist('ind_data','var') ~= 1)
    % luodaan vain kerran! 
    % Jos haluat arpoa uudet pisteet, sano tai lis rivi "clear ind_data"
    ind_data = randperm(N);
end;
No = round(0.8*N);               % 80 % opetusdataan!
Nt = No+1;
disp(['Valitaan opetusdataan N_o = ' num2str(No) ' nytett ja']);
disp(['testidataan N_t = ' num2str(N-No) ' nytett.']);

train = data(:, ind_data(1 : No));
test  = data(:, ind_data(Nt : end));
classtrain = dclass(ind_data(1 : No));
classtest  = dclass(ind_data(Nt :end));
N_train_A = sum(classtrain == 1);
N_test_A = sum(classtest == 1);

disp(['Nyt opetusjoukossa ' num2str(N_train_A) ' "+1":st ja ' num2str(No-N_train_A) ' "-1":st']);
disp(['ja testijoukossa ' num2str(N_test_A) ' "+1":st ja ' num2str((N-No)-N_test_A) ' "-1":st']);

%% Piirretn data
% Siniset rastit ovat opetusjoukon nytteit?, joiden
% luokka on +1,  siniset pallot opetusjoukon n?ytteit?,
% joilla luokka -1 ja mustat timantit testijoukon n?ytteit?,
% joiden luokkatieto tunnetaan, mutta se hydynnetn
% vasta laskettaessa luokittimen tuottamaa virhett.

ind_A = find(classtrain > 0);
ind_B = find(classtrain < 0);

figure(100+kNN); clf;
plot(train(1,ind_A), train(2, ind_A), 'bx');
hold on;
plot(train(1,ind_B), train(2, ind_B), 'bo');
pl1 = plot(test(1,:), test(2,:), 'kd');
title('Opetusdata kahdessa luokassa ja testidata');
legend({'Luokka +1 (train)','Luokka -1 (train)','Luokiteltavat pisteet (test)'});
axis equal;
grid on;

%% Lasketaan etisyysmatriisi datapisteist
DistVect   = pdist([train test]');
DistMatrix = squareform(DistVect);
Dist       = DistMatrix(Nt:end, 1:No);
% Tss ensimmisess riviss on etisyydet
% ensimmisest testipisteest kaikkiin opetuspisteisiin, jne.

% HUOM! HUOM! Jos pdist ja squareform aiheuttavat ongelmia,
% niin korvataan ne kaksi rivi yhdell rivill:
%
% DistMatrix = myDistSquareform([train test]');

%% Lasketaan k-NN
class_correct   = 0;
class_incorrect = 0;
class_A = [];
class_B = [];
ind_incorrect = [];
class_A_was_B = [];
class_B_was_A = [];
 
% Jokaiselle testipisteelle:
for m = 1 : (N-No)
    [mins, ind_mins] = sort(Dist(m, :));
    classified = sum(dclass(ind_data(ind_mins(1:kNN))));
    if (sign(dclass(ind_data(m + No))) == sign(classified))
        class_correct = class_correct + 1;
        if (classified > 0)
            class_A = [class_A m];
        else
            class_B = [class_B m];
        end         
    else
        class_incorrect = class_incorrect + 1;
        ind_incorrect = [ind_incorrect m];
        if (classified < 0)
            class_A_was_B = [class_A_was_B m];
        else
            class_B_was_A = [class_B_was_A m];
        end         
    end;
end;

error = 100 * class_incorrect / (N-No);

disp(['Luokittelun tulos ' num2str(kNN) '-NN:']);
disp(['  oikein:  ' num2str(class_correct)]);
disp(['  vrin:  ' num2str(class_incorrect)]);
disp(['Luokitteluvirhe: ' num2str(error) '%']);        

if (exist('pl1','var') == 1), delete(pl1); end;

plot(test(1,class_A), test(2, class_A), 'gx');
plot(test(1,class_B), test(2, class_B), 'go');
plot(test(1,class_A_was_B), test(2, class_A_was_B), 'rx');
plot(test(1,class_B_was_A), test(2, class_B_was_A), 'ro');

title([num2str(kNN) '-NN: Opetusdata kahdessa luokassa, oikein ja vrin luokitetut']);
legend({'Luokka +1 (train)','Luokka -1 (train)', ...
    ['Oikein +1 [' num2str(length(class_A)) ']'], ...
    ['Oikein -1 [' num2str(length(class_B)) ']'], ...
    ['Vrin +1 [' num2str(length(class_A_was_B)) ']'], ...
    ['Vrin -1 [' num2str(length(class_B_was_A)) ']']});
shg;

%% Vertailu, kommentit
%
% * etsi molempien luokkien testipisteet, jotka on luokiteltu vrin / oikein
% * luokitteluvirheet 1-NN, 3-NN, 5-NN?
% * mit hyv / huonoa eri k:n arvoilla (k = 1, 3, 5)
