%% DT_T3_d3.m
% T-61.2010 Datasta tietoon 
% Tietokoneharjoitus #3
% Demo 3
%
% Jukka Parviainen, jukka.parviainen@aalto.fi, 20111026

%% Siistimist, jos tarpeen

clear;         % poista muistista muuttujat
clc;           % puhdista komentoikkunan ruutu
close all;     % sulje kaikki ikkunat

%% k:n lhimmn naapurin luokitin / k-nearest neighbour classifier
%
% Jatketaan edellist tehtv samalla tunnetulla datalla,
%  mutta nyt otetaan yhden sijasta kolme lhint naapuria 
%  eli k = 3 (voit vaihtaa arvoa rivill 25).
% Uusi datapiste (vaihda rivill 24) luokitellaan nyt siis 
%  siihen luokkaan, johon enemmist lhimmist k:sta 
%  naapurista kuuluu.
% Olkoon uusi datapiste:

C = [4 4]';  % voit kirjoittaa thn haluamasi pisteen
k = 3;       % voit kokeilla muutakin k:n arvoa

disp(['Mihin luokkaan (A vai B) seuraava datapiste kuuluu, kun k=' num2str(k) '?']);
disp(C);

%% Luokkien A ja B data
A = [ 0  1  3     5    8.5; ...
      0  3  1.8  -0.8  3.3]
  
B = [ 5.2   8   9   12; ...
      3.5  -3   0.5 2.5]

A_lkm = size(A, 2);

figure(331); clf;
pA = plot(A(1,:), A(2,:), 'o');
hold on;
pB = plot(B(1,:), B(2,:), 's');
axis equal
grid on;
axis([-2.2 14.5 -5.2 5.8]);
set(gca,'XTick',[-10:1:30],'YTick',[-10:1:20]);
legend({'luokka/class A','luokka/class B'});
title('Opetusaineisto luokkiin A ja B');

%%  Piirretn tilanne

plo1 = plot(C(1,1), C(2,1), 'r*');
tex1 = text(C(1,1)+0.2, C(2,1), '?');
set([tex1],'Color','r','FontSize',16);
title(['Opetusaineisto sek luokiteltava piste, kun k = ' num2str(k)]);
shg;

%% Lasketaan yhdelle pisteelle etisyydet kaikkiin muihin
%
% Esimerkki: pisteen C(1) ja kaikkien opetuspisteiden etisyydet
% Kytetn etisyyden laskemiseen euklidista etisyytt:
%
% $$ dist = \sqrt{ (c_1 - x_1)^2 + (c_2 - x_2)^2 } $$
%

distC1 = zeros(1,size(A,2)+size(B,2));
for j = [1 : size(A,2)]
    distC1(j) = sqrt( (C(1,1)-A(1,j))^2 + (C(2,1)-A(2,j))^2 );
end;
for j = [1 : size(B,2)]
    distC1(j+size(A,2)) = sqrt( (C(1,1)-B(1,j))^2 + (C(2,1)-B(2,j))^2 );
end;

disp('Pisteen C(1)');
disp(C(:,1));
disp('etisyydet A:n ja B:n pisteisiin:');
disp(distC1);

% Piirretn kuvaajaan (tss pelkki piirtokomentoja!!)

lin6 = zeros(size(A,2)+size(B,2),1);
for j = [1 : size(A,2)]
    lin6(j) = line([C(1,1) A(1,j)],[C(2,1) A(2,j)],'Color',[0 0 0]);
    tex2(j) = text(A(1,j)+0.5, A(2,j)-0.5, num2str(distC1(j))); 
end;
for j = [1 : size(B,2)]
    lin6(j+size(A,2)) = line([C(1,1) B(1,j)],[C(2,1) B(2,j)],'Color',[0 0 0]);
    tex3(j) = text(B(1,j)+0.5, B(2,j)-0.5, num2str(distC1(j+size(A,2)))); 
end;
[distx, indx] = sort(distC1);
set(lin6(indx(1:k)),'LineWidth',3);

title(['Opetusaineisto ja luokiteltava piste, kun k=' num2str(k)]);
shg;

%% Eli luokitellaan piste C(1) lhimmn naapurin mukaan!
% (taas pelkki piirtokomentoja)

% Poistetaan ensin punaisia hsskit
delete(lin6(indx(k+1:end)));
delete(tex2);
delete(tex3);

if (sum(indx(1:k) > 5.5) > (k/2))
    disp('Piste C kuuluu luokkaan B');
    set(plo1,'Marker','s');
    set(tex1,'String', 'B');
elseif (sum(indx(1:k) > 5.5) < (k/2))
    disp('Piste C kuuluu luokkaan A');
    set(plo1,'Marker','o');
    set(tex1,'String', 'A');
else
    disp('Tasapeli -- Heit lanttia!');
end;

shg;

