%% DT_T3_d4.m
% T-61.2010 Datasta tietoon 
% Tietokoneharjoitus #3
% Tehtv 4
%
% Jukka Parviainen, jukka.parviainen@aalto.fi, 20111026

%% Luokittelua 1D-datalle "mies-nainen"
%  - tehtv: luokittele mittaus x = 173 cm mieheksi tai
%    naiseksi
%  - data:
%    * 25 miest (Xm), 9 naista (Xn)
%  - menetelm (kokeile yksi tai kaikki)
%    (a) kNN, valitse parametri k
%    (b) ehdollisten todennkisyyksien perusteella
%        p(x=173|mies) ? p(x=173|nainen)
%    (c) ottamalla huomioon ehdollisten todennkisyyksien
%        lisksi luokkien todennkisyydet (prior); "Bayes"
%          p(w=mies) ~ p(x|mies)p(mies)
%          p(w=nainen) ~ p(x|nainen)p(nainen)
%        Luokkien todennkisyydet laskemalla opetusdatan
%        frekvenssit p(mies) = #mies / (#mies + #nainen), jne.
%  - komentoja:
%    * euklidiset etisyydet voi laskea esim. norm(x1-x2)
%    * etisyyksien jrjestminen [arvot, indeksit] = sort(etaisyydet)
%    * tai Matlabin valmiilla komennoilla liittyen kNN

%% Piirretn data

load -ascii Xm.csv
load -ascii Xn.csv

figure(341); clf;
plot(Xm,0.01*rand(size(Xm)),'bo');
hold on;
plot(Xn,0.05+0.01*rand(size(Xn)),'rs');
axis([0.9*min([Xm;Xn]) 1.1*max([Xm;Xn]) 0 0.3]);


%% (a) kNN
%
% Onko x = 173 cm mies vai nainen?
%
% Voit laskea demojen pdist-funktiolla etisyydet
%  tai kytt for-looppia laskemaan etisyys. Matlabissa
%  abs() antaa itseisarvon.

% <TOTEUTUS>


% Vastaus: x = 173 --> mies/nainen

%% (b) p(x|mies) ? p(x|nainen)
%
% Onko x = 173 cm mies vai nainen?
%
% Voit laskea demo #1 :n normfit-funktiolla (tai mle)
%  molemmat ehdolliset tiheysfunktiot. Pttele tulos saadun
%  kuvan perusteella tai laske normpdf-funktiolla arvot
%  molemmille funktiolle.


% <TOTEUTUS>

% Vastaus: x = 173 --> mies/nainen

%% (c) "Bayes" = likelihood x prior
%
% Onko x = 173 cm mies vai nainen?
%
% Voit laskea demo #1 :n normfit-funktiolla (tai mle)
%  molemmat ehdolliset tiheysfunktiot p(x|luokka). 
%  Laske datasta luokkien prioritodennkisyydet
%  p(mies) = #mies / (#mies + #nainen), jne.
%  Piirr p(luokka)-skaalatut funktiot tai laske 
%  normpdf-funktiolla skaalatut arvot.

% <TOTEUTUS>

% Vastaus: x = 173 --> mies/nainen

